<template>
  <div class="almost-there fixed inset-0 z-10" @click="closeAlmostThere">
    <div class="flex h-full justify-center items-center">
      <div
        id="almostThereContent"
        class="almost-there__content animated-modal xs:w-full xs:rounded-t-32 xs:rounded-b-none xs:fixed bottom-0 left-0 rounded-32 bg-bgdsec xs:rounded-none"
        @click.stop
      >
        <div class="p-8 xs:p-4">
          <div class="flex items-center justify-between">
            <p class="font-bold text-2xl xs:text-lg xs:leading-5 leading-7 text-txtdprim">{{ $t('almost.title') }}</p>
            <UiButton
              color-type="secondary"
              button-height="sm"
              class="w-12 rounded-16"
              @click.native="closeAlmostThere"
            >
              <img width="24" height="24" src="@/assets/images/ui/ui-cross.svg" />
            </UiButton>
          </div>
          <UiInput v-model="email" :placeholder="$t('almost.email') + '...'" class="mt-12">
            <img width="24" height="24" src="@/assets/images/ui/ui-email.svg" />
          </UiInput>
          <UiInput v-model="name" max-length="15" :placeholder="$t('almost.name') + '...'" class="mt-4">
            <img width="24" height="24" src="@/assets/images/ui/ui-person.svg" />
          </UiInput>
          <div class="mt-12 px-4 gap-4 flex items-center">
            <div
              class="w-6 h-6 rounded-8 cursor-pointer flex items-center justify-center"
              :class="isChecked ? 'bg-blue' : 'bg-transparent shadow-inpdhov'"
              @click="isChecked = !isChecked"
            >
              <img v-if="isChecked" src="@/assets/images/ui/check-white.svg" />
            </div>
            <p class="flex-1 text-txtdsec font-medium text-sm leading-6">
              {{ $t('almost.terms.1') }}
              <a href="https://flashnodes.io/terms-of-service" target="_blank" class="underline underline-offset-2">
                {{ $t('almost.terms.2') }}
              </a>

              {{ $t('almost.terms.3') }}
              <a href="https://flashnodes.io/privacy-policy" target="_blank">
                <span class="underline underline-offset-2">{{ $t('almost.terms.4') }}</span
                >,
              </a>
              {{ $t('almost.terms.5') }}
            </p>
          </div>
          <UiButton
            :disabled="!buttonEnabled"
            color-type="primary"
            button-height="md"
            class="mt-12 rounded-24"
            @click="updateUserInfo"
          >
            <span v-if="!loading">{{ $t('almost.submit') }}</span>
            <LoadingSpinner color-type="white" v-else />
          </UiButton>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import { updateUserInfo } from '@/api';

import UiInput from '@/components/ui/UiInput.vue';
import UiButton from '@/components/ui/UiButton.vue';
import LoadingSpinner from '@/components/ui/LoadingSpinner.vue';

export default {
  name: 'AlmostThere',

  components: { UiInput, UiButton, LoadingSpinner },

  data() {
    return {
      isChecked: false,

      email: '',
      name: '',

      loading: false,
    };
  },

  computed: {
    emailValidated() {
      return Boolean(this.email) && /^\S+@\S+\.\S+$/.test(this.email);
    },

    nameValidated() {
      return Boolean(this.name);
    },

    buttonEnabled() {
      return this.emailValidated && this.nameValidated && this.isChecked;
    },
  },

  methods: {
    closeAlmostThere() {
      if (this.loading) return;
      this.$store.commit('setAlmostThereDisplay', false);
    },

    async updateUserInfo() {
      this.loading = true;
      try {
        await updateUserInfo({ full_name: this.name, email: this.email });

        await this.$store.dispatch('getUserInfo');
        this.loading = false;
        this.closeAlmostThere();
      } catch (err) {
        console.error(err);
        this.$store.dispatch('setErrorPopupDisplay', {
          display: true,
          text: 'email',
        });
      } finally {
        this.loading = false;
      }
    },
  },
};
</script>

<style lang="scss">
.almost-there {
  background: rgba(12, 21, 33, 0.64);

  &__content {
    width: 500px;

    @media (max-width: 600px) {
      max-height: calc(100vh - 75px);
    }
  }
}

.dark {
  .almost-there {
  }
}
</style>
